import sys
import thread
import uuid

from amqplib import client_0_8 as amqp

def receive(msg):
    msg.channel.basic_ack(delivery_tag=msg.delivery_tag)
    print 'Got response: %s' % msg.body

def spew(host, user, password, vhost, exchange):
    def spew_one():
        conn = amqp.Connection(host=host, userid=user, password=password, virtual_host=vhost)
        try:
            chan = conn.channel()
            queue = str(uuid.uuid4())
            try:
                chan.exchange_declare(exchange=exchange, type='topic', durable=False)
                chan.queue_declare(queue=queue, durable=False, exclusive=False, auto_delete=True)
                chan.queue_bind(queue=queue, exchange=exchange, routing_key=queue)
                msg = amqp.Message(queue)
                chan.basic_publish(msg, exchange=exchange, routing_key='request')

                while True:
                    resp = chan.basic_get(queue)
                    if resp:
                        break

                chan.basic_ack(delivery_tag=resp.delivery_tag)
            finally:
                chan.queue_delete(queue)
                chan.close()
        finally:
            conn.close()

    while True:
        spew_one()

def main():
    for dummy in xrange(4):
        thread.start_new_thread(spew, ('localhost', 'guest', 'temp1234', '/', 'demo'))
    sys.stdin.readline()

if "__main__" == __name__:
    sys.exit(main())
